io.stdout:setvbuf("no")
function reloadLuaFile(filePath)
    package.loaded[filePath] = nil
    return require(filePath)
end

function reloadAllScripts()
    _G.json = reloadLuaFile("scripts._SDK.json")
    _G.ini = reloadLuaFile("scripts._SDK.ini")
    _G.utils = reloadLuaFile("scripts._SDK.utils")
    _G.config = reloadLuaFile("scripts.config")
    _G.block = reloadLuaFile("scripts.auto_block")
    if _G.self_Id and _G.enemy_Id then
        print("reloadAllScripts")
        loadCharacterScript(_G.self_Id, _G.enemy_Id)
    end
end

function fileExists(filename)
    local file = io.open(filename, "r")
    if file then
        file:close()
        return true
    else
        return false
    end
end

function getCharacterName(characterID)
    for id, name in pairs(config.characters) do
        if id == characterID then
            return name
        end
    end
    return nil
end

function loadCharacterScript(self_charId, enemy_charId)
    _G.self_Id = self_charId
    _G.enemy_Id = enemy_charId

    local selfCharacterName = getCharacterName(self_charId)
    local enemyCharacterName = getCharacterName(enemy_charId)

    print("[+] Loaded Character: " .. selfCharacterName .. " (ID: " .. self_charId .. ")")

    local selfScriptPath = "scripts.Character." .. selfCharacterName
    if fileExists("scripts\\Character\\" .. selfCharacterName .. ".lua") then
        -- Reload self character script
        selfScript = nil
        selfScript = reloadLuaFile(selfScriptPath)
        if selfScript then
            print("[Success] Loaded self script: " .. selfCharacterName .. " successfully!")
        else
            print("Failed to load self script:", selfScriptPath)
        end
    else
        selfScript = nil
		selfScript = reloadLuaFile("scripts.Character.Default")
        print("Self script file does not exist:", selfScriptPath)
    end
    -- Not using Because it may conflict
    --local enemyScriptPath = "scripts.Character." .. enemyCharacterName
    --if fileExists("scripts\\Character\\" .. enemyCharacterName .. ".lua") then
    --    -- Reload enemy character script
    --	enemyScript = nil;
    --    enemyScript = reloadLuaFile(enemyScriptPath)
    --    if enemyScript then
    --        print("[Success] Loaded enemy script: "..enemyCharacterName.." successfully!")
    --    else
    --        print("Failed to load enemy script:", enemyScriptPath)
    --    end
    --else
    --    print("Enemy script file does not exist:", enemyScriptPath)
    --end
end



function onFrameDataReceived(game_snapshot)
    if utils.IsSpecialStatus(game_snapshot.self) then
        return
    end
    if block:OppIsThrowing(game_snapshot.self, game_snapshot.enemy) then
        TechCombos(game_snapshot.self, game_snapshot.enemy)
    end
    block:DefendAndCounter(game_snapshot.self, game_snapshot.enemy)
    block:AttackIfPossible(game_snapshot.self, game_snapshot.enemy)
end

function onTrackFramesData(game_snapshot)

end

function TechCombos(self, enemy)
    if not utils.IsMoveChanged(false, enemy) then
        return
    end

    math.randomseed(os.time())
    local autoRate = math.random(0, 100)
    if config.THROW_BREAK_CHANCE < autoRate then
        return
    end
    local randomDelay = math.random(1, 10) -- random delay between 1 and 10 frames (adjust as needed)    
    delayFrames(randomDelay) -- random delay before executing the throw break
    
    local randomPressDuration = math.random(2, 25) -- Adjust the number of frames the throw break button is pressed 

    if self.throw_tech == ThrowType.TE1_2 then
        executeMacro(0, Input.L_HAND + Input.R_HAND, randomPressDuration, InputType.KEY_PRESS)
    elseif self.throw_tech == ThrowType.TE1 then
        executeMacro(0, Input.L_HAND, randomPressDuration, InputType.KEY_PRESS)
    elseif self.throw_tech == ThrowType.TE2 then
        executeMacro(0, Input.R_HAND, randomPressDuration, InputType.KEY_PRESS)
    end
end

function onKeyInput()
    if is_key_down(Keys.Q) then
        executeMacro(Input.BACK, 0, 1, InputType.KEY_PRESS)
        executeMacro(Input.BACK + Input.DOWN, 0, 1, InputType.KEY_PRESS)
        executeMacro(Input.BACK, 0, 1, InputType.KEY_PRESS)
    end
    if is_key_down(Keys.Z) then
		executeMacro(Input.UP+Input.BACK, Input.L_HAND+Input.R_HAND, 3, InputType.KEY_PRESS)
	end
end
